from __future__ import annotations

from pathlib import Path
from typing import List

from maldump.parsers.malwarebytes_parser import MalwarebytesParser
from maldump.structures import Quarantine, QuarEntry


class Malwarebytes(Quarantine):
    """Implements Malwarebytes quarantine format"""

    def __init__(self) -> None:
        super().__init__()
        self.name = 'Malwarebytes'
        self.location = Path('ProgramData/Malwarebytes/MBAMService/Quarantine')

    def export(self) -> List[QuarEntry]:
        quarfiles = MalwarebytesParser().from_file(
            name=self.name,
            location=self.location
        )

        return quarfiles
